// File:        misc.h
// Purpose:     misc. sector generation definitions
// Author:
// Created:
// Updated:
// Copyright:   LGPL
// Traveller is a registered trademark of Far Future Enterprises.
// Portions based upon material Copyright 1977-2002 Far Future Enterprises.
// 
// rcsid[] = "$RCSfile: misc.h,v $ $Revision: 1.2 $ $Author: man $ $Date: 2002/06/05 04:51:07 $"


#ifndef TRADEGEN_H
#define TRADEGEN_H

#include "codetbl.h"

#define JUMP_FILE	"jump.dat"
#define TRADE_FILE	"trade.dat"
#define PORT_FILE	"mature.dat"

#if 0
// --------------------------------------------------------------------------
// base linked list class, mostly just a wrapper around file parsing
class ParseClass : public LinkedList
{
public:
	ParseClass();
	virtual ~ParseClass();

	// XXX Init/Load are hokey kludges!!!!
	void Init(char *f);

	virtual void Load(char *f)=0;
};

// --------------------------------------------------------------------------
// trade codes --
typedef enum {
	TGC_NONE=0,
	TGC_IN,			// 2-4,7,9
	TGC_RI			// 6,8
} TRADE_GEN_CODE;
#endif

class GenCode : public ListData
{
public:
	GenCode(char *);
	~GenCode();

	bool Check(char *u);
	char *GetCode(void) { return(code); };

private:
	char			code[3];		// yup, limit to 2 chars
	TRADE_GEN_CODE	special;
	int				mins[6];
	int				maxs[6];
};

#if 0
class TradeGen : public ParseClass
{
public:
	TradeGen(char *f);
	~TradeGen();

	unsigned long CheckTrade(char *u, CodeTable *ct);

	void Load(char *buff, bool local=FALSE);

private:

};
#endif

// --------------------------------------------------------------------------
// starport generation
class PortGenEntry : public ListData
{
public:
	PortGenEntry(char *m);
	~PortGenEntry();

	char *GetPorts(void) { return(mat); };

private:
	char	mat[12];
};

class PortGen : public ParseClass
{
public:
	PortGen(char *f);
	~PortGen();

	char GenPort(int ndx);
	void Load(char *buff, bool local=FALSE);

};

// --------------------------------------------------------------------------
// default jump routes  
class JumpRouteEntry : public ListData
{
public:
	JumpRouteEntry(char *j);
	~JumpRouteEntry();

	char *GetPairs(void) { return(pair); };
	int GetTarget(int ndx);

private:
	char	pair[3];
	int		targs[4];
};

class JumpRoute : public ParseClass
{
public:
	JumpRoute(char *f);
	~JumpRoute();

	bool CheckRoute(char p1, char p2, int d);
	void Load(char *buff, bool local=FALSE);

};

#endif

